SystemOrganization addCategory: #Prototalk!
SystemOrganization addCategory: #'Prototalk-Tests'!
SystemOrganization addCategory: #'Prototalk-Demo'!

!Symbol methodsFor: '*prototalk' stamp: 'mab 1/31/2008 17:11'!
asMethodDefinitionWith: arguments
	| argCount string |
	argCount := self count: [ :c | c = $: ].
	arguments size ~= argCount ifTrue: [
		Error signal: 'Wrong argument number' ].
	argCount isZero ifTrue: [ ^ self asString ].
	string := String new.
	(self subStrings: ':') doWithIndex: [ :part :index |
		string := string, part, ': ', (arguments at: index) asString allButFirst allButLast, ' '].
	^ string! !

!Object methodsFor: '*prototalk' stamp: 'mab 1/27/2008 22:19'!
addMethod: code
	self asPrototalkObject meta protocol addMethod: code for: self! !

!Object methodsFor: '*prototalk' stamp: 'mab 1/31/2008 17:05'!
addMethod: aName with: aBlock
	self asPrototalkObject meta protocol addMethod: aName with: aBlock for: self! !

!Object methodsFor: '*prototalk' stamp: 'mab 1/29/2008 11:55'!
asPrototalkObject
	self hasExtendableMeta ifFalse: [
		self asCodAObject].
	self meta state = ProtoTalkComponent ifFalse: [self meta install: ProtoTalkComponent at: #State for: self].
	self meta protocol = ProtoTalkComponent ifFalse: [ self meta install: ProtoTalkComponent at: #Protocol for: self].
	! !

!Object methodsFor: '*prototalk' stamp: 'mab 1/31/2008 16:26'!
protoClone
	| clone |
	clone := Object new asPrototalkObject.
	self meta state slotIds do: [ :name | 
			clone meta state addVariable: name for: clone.
			clone perform: name asMutator with: (self meta state at: name asSymbol for: self)]. 
	clone meta state at: #prototype put: self for: clone.
	self hasExtendableMeta ifTrue: [
		clone meta oldObject: self meta oldObject].
	^clone! !

!Object methodsFor: '*prototalk' stamp: 'je 1/25/2008 18:27'!
slotIds
	^ self meta state slotIdsFor: self! !

Object subclass: #PTAnimal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototalk-Demo'!

!PTAnimal methodsFor: 'as yet unclassified' stamp: 'je 1/28/2008 18:19'!
demoMethod
	| sheep spider |
	sheep := nil protoClone.
	sheep addMethod: 'legs
	^4'.
	sheep addMethod: 'saySomething
	^'' I have '', self legs asString, '' legs!!!!!!'''.
	spider := sheep protoClone.
	spider addMethod: 'legs
	^8'.
	Transcript show: spider saySomething! !

!PTAnimal methodsFor: 'as yet unclassified' stamp: 'je 1/28/2008 17:33'!
doSomething
	^ 'I am alive!!'! !

Object subclass: #ProtoTalkSimpleObject
	instanceVariableNames: 'variable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototalk-Tests'!

!ProtoTalkSimpleObject methodsFor: 'as yet unclassified' stamp: 'je 1/26/2008 16:35'!
sayHello
	^ 'hello!!'! !

!ProtoTalkSimpleObject methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 01:04'!
testMethod
	^ 42! !

BouncingAtomsMorph subclass: #PTDemoMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototalk-Demo'!

!PTDemoMorph methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 16:27'!
addAtoms: n
	"Add a bunch of new atoms."

	| a |
	n timesRepeat: [
		a := AtomMorph new protoClone.
		a randomPositionIn: bounds maxVelocity: 10.
		self addMorph: a].
	self stopStepping.! !

!PTDemoMorph methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 16:02'!
initialize
	super initialize.
	
	
	! !

!PTDemoMorph methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 16:02'!
stepTime
	^ 100! !

!UndefinedObject methodsFor: '*prototalk' stamp: 'mab 1/28/2008 00:54'!
protoClone
	| clone |
	clone := Object new.
	clone asPrototalkObject meta state at: #prototype put: self for: clone.
	clone asPrototalkObject meta oldObject: self.
	^clone! !

!BlockNode methodsFor: '*prototalk' stamp: 'mab 1/31/2008 17:06'!
arguments
	^ arguments! !

!BlockNode methodsFor: '*prototalk' stamp: 'mab 1/31/2008 17:08'!
temporaries
	^ temporaries! !

CodAMetaComponent subclass: #ProtoTalkComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototalk'!

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'mab 1/31/2008 17:25'!
addMethod: code for: anObject
	| method selector |
	selector := anObject meta anonymClass 
		compileSilently: code classified: Categorizer allCategory.
	method := anObject meta anonymClass compiledMethodAt: selector.
	anObject meta anonymClass removeSelector: selector.
	anObject methods at: selector put: method.! !

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'mab 1/31/2008 17:08'!
addMethod: aName with: aBlock for: anObject
	| blockNode code |
	blockNode := aBlock decompile.
	code := (aName asMethodDefinitionWith: blockNode arguments), String cr, '|'.
	blockNode temporaries do: [ :temp |
		code := code, temp] separatedBy: [ code := code, ' '. ].
	code := code, '|', String cr.
	blockNode statements do: [ :statement |
		code := code, statement asString allButFirst allButLast] separatedBy: [
		code := code, '.', String cr].
	self addMethod: code for: anObject.
	! !

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 13:54'!
addVariable: variableSymbol for: anObject
	self addMethod: variableSymbol asString, '
	^ self meta state at: ', variableSymbol asSymbol asExplorerString, ' for: self' for: anObject.
	self addMethod: variableSymbol asString, ': anObject
	self meta state at: ', variableSymbol asSymbol asExplorerString, ' put: anObject for: self.
	^ anObject' for: anObject.! !

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'mab 1/27/2008 23:37'!
at: id for: anObject
	^anObject slots at: id! !

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'je 1/25/2008 18:23'!
at: id put: value for: anObject
	anObject slots at: id put: value.! !

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'mab 1/31/2008 17:28'!
installingOn: aSymbol for: anObject
	aSymbol = #State ifTrue: [
		anObject meta anonymClass compileSilently: 'slots
	^self codAExtension at: #slots ifAbsent: [ self codAExtension at: #slots put: Dictionary new ]' classified: Categorizer allCategory.
		anObject meta anonymClass compileSilently: 'slots: val
	^ self codAExtension at: #slots put: val' classified: Categorizer allCategory.
		anObject meta anonymClass compileSilently: 'methods
	^self codAExtension at: #methods ifAbsent: [ self codAExtension at: #methods put: Dictionary new]' classified: Categorizer allCategory.
		anObject meta anonymClass compileSilently: 'methods: val
	^ self codAExtension at: #methods put: val' classified: Categorizer allCategory.
		anObject meta anonymClass compileSilently: 'asPrototalkObject
	^ self' classified: Categorizer allCategory.].! !

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 13:54'!
methodFor: aMessage for: anObject
	| prototype method |
	method := anObject methods at: aMessage selector ifAbsent: [
		((anObject meta state slotIdsFor: anObject) includes: #prototype) ifTrue: [
			prototype := anObject meta state at: #prototype for: anObject.
			prototype meta protocol methodFor: aMessage for: prototype] ifFalse: [
			"we have no prototype"
			anObject meta oldObject class methodFor: aMessage for: anObject meta oldObject]].
	method isNil & (aMessage arguments size = 1) ifTrue: [
		"an accessor for a new slot"
		self addVariable: aMessage selector allButLast for: anObject.
		^ self methodFor: aMessage for: anObject. ].
	^ method! !

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'je 1/25/2008 18:23'!
slotIdsFor: anObject
	^anObject slots keys.! !

TestCase subclass: #ProtoTalkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototalk-Tests'!

!ProtoTalkTest methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 13:53'!
testAddVariable
	| object |
	object := Object new asPrototalkObject.
	object magic: 'Some beautiful magic'.
	self assert: object magic = 'Some beautiful magic'.! !

!ProtoTalkTest methodsFor: 'as yet unclassified' stamp: 'mab 1/31/2008 17:33'!
testBlockMethodWithVariable
	| object |
	object := 'juri'.
	object addMethod: #calculate: with: [ :x | self variable: x * 3 ].
	object calculate: 14.
	self assert: object variable = 42.! !

!ProtoTalkTest methodsFor: 'as yet unclassified' stamp: 'mab 1/31/2008 17:13'!
testBlockMethods
	| object |
	object := 'juri'.
	object addMethod: #calculate: with: [ :x | ^ x * 3 ].
	self assert: (object calculate: 14) = 42.! !

!ProtoTalkTest methodsFor: 'as yet unclassified' stamp: 'mab 1/31/2008 16:19'!
testClone
	| blub blubsClone |
	blub := Morph new.
	blubsClone := blub protoClone.
	blub class instVarNames do: [:id | self assert: ((blubsClone meta state slotIdsFor: blubsClone) includes: id asSymbol)]
! !

!ProtoTalkTest methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 13:53'!
testCloneFromClone
	| original firstClone secondClone |
	original := ProtoTalkSimpleObject new.
	firstClone := original protoClone.
	secondClone := firstClone protoClone.
	self assert: (secondClone testMethod = 42)
! !

!ProtoTalkTest methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 13:53'!
testClonedClassMethods
	| obj clone |
	obj := 'Juri' asPrototalkObject.
	clone := obj protoClone.
	clone hash.
	! !

!ProtoTalkTest methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 13:54'!
testConverting
	| object |
	object := Object new asPrototalkObject.
	self assert: (object name = 'an Object').
! !

!ProtoTalkTest methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 14:23'!
testDemo
	| juri |
	juri := 'Juri' addMethod: 'sayHello
		^ ''Hallo ich bin '', self, ''!!'''.
	juri addMethod: 'sayHelloTo: other
		^ ''Hallo '', other, '', ich bin '', self, ''!!'''.! !

!ProtoTalkTest methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 13:54'!
testExNihilo
	| o |
	o := nil protoClone.
	o addMethod: 'huhu
'.

	self shouldnt: [o huhu] raise: MessageNotUnderstood! !

!ProtoTalkTest methodsFor: 'as yet unclassified' stamp: 'mab 1/31/2008 17:54'!
testNumber
	| fourteen |
	fourteen := 14 wrappedByCodA.
	fourteen addMethod: #answer with: [ ^ self * 3 ].
	self assert: (fourteen answer = 42).! !

!ProtoTalkTest methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 13:54'!
testObjectMethods
	| o1 |
	o1 := 'Juri'.
	o1 addMethod: 'huhu
'.

	self shouldnt: [o1 huhu] raise: MessageNotUnderstood.
	self assert: ((o1 at: 1) = $J)! !
